export function transformersByType(transformers) {
    const byType = indexBy(transformers, t => t.type);
    return {
        element: byType.element || [],
        textFormat: byType['text-format'] || [],
        textMatch: byType['text-match'] || []
    };
}
export const PUNCTUATION_OR_SPACE = /[!-/:-@[-`{-~\s]/;

export function indexBy(list, callback) {
    const index = {};
    for (const item of list) {
        const key = callback(item);
        if (index[key]) {
            index[key].push(item);
        } else {
            index[key] = [item];
        }
    }
    return index;
}