import React, {useRef, useState} from 'react';
import {Layout, Avatar, Tabs} from 'antd';
import Hlexical from '@/pages/Note/Hlexical';
import ItemTree from "@/components/ItemTree";
import '@/pages/Note/index.less'
import {useSelector, useDispatch} from "react-redux";
import {addTableBarItem, removeTableBarItem, setActiveKey, editLeftTableOfContents} from "@/redux/tableBarItem_reducer"
const {Sider} = Layout;
const { TabPane } = Tabs;
const Note = () => {
    const dispatch = useDispatch()
    const [collapsed, setCollapsed] = useState(false);
    //   const {
    //     token: { colorBgContainer },
    //   } = theme.useToken();
    const colorBgContainer = '#800080'
    const newTabIndex = useRef(0);

    const activeKey = useSelector(state => state.tableBarItem.activeKey);
    const itemList = useSelector(state => state.tableBarItem.data)
    let filePath = useSelector(state => state.dirMessage.dirTree);
    console.log("itemList", itemList)
    const itemTreeTab = [
        {
            key: '1',
            label: '文件',
            children: <ItemTree filePath={filePath}></ItemTree>,
        }, {
            key: '2',
            label: '目录',
            children: <div id="leftTableOfContents"></div>,
            forceRender: true
        }
    ]
    const onChange = (newActiveKey) => {
        console.log("setActiveKey(newActiveKey)", newActiveKey)
        dispatch(setActiveKey({"activeKey": newActiveKey}));
    };
    const onChangeLeftTableOfContents = (activeKey) => {
        dispatch(editLeftTableOfContents({"leftTableOfContents": activeKey}))
    }
    const add = () => {
        const newActiveKey = `newTab${newTabIndex.current++}`;
        dispatch(addTableBarItem(
            {
                label: newActiveKey,
                // children: "",
                key: newActiveKey,
                activeKey: newActiveKey
            }
        ));
    };
    const remove = (targetKey) => {
        console.log("remove = (targetKey):", targetKey)

        let lastIndex = -1;
        itemList.forEach((item, i) => {
            if (item.key === targetKey) {
                lastIndex = i - 1;
            }
        });
        dispatch(removeTableBarItem(targetKey));
        const newPanes = itemList.filter((item) => item.key !== targetKey);
        let newActiveKey;
        if (newPanes.length) {
            if (lastIndex >= 0) {
                newActiveKey = newPanes[lastIndex].key;
            } else {
                newActiveKey = newPanes[0].key;
            }
        }
        dispatch(setActiveKey({"activeKey": newActiveKey}));
    };
    const onEdit = (targetKey, action) => {
        if (action === 'add') {
            add();
        } else {
            remove(targetKey);
        }
    };

    return (
        <Layout>
            <Sider trigger={null} collapsedWidth={0} width="300px" collapsible collapsed={collapsed}
                   style={{overflow: "hidden"}}>
                {/* 文件 标题 */}
                <Tabs id="itemTreeTabs"
                      defaultActiveKey={useSelector(state => state.tableBarItem.leftTableOfContents)}
                      items={itemTreeTab}
                      onChange={onChangeLeftTableOfContents}
                      style={{background: "#fff", width: '100%'}}
                />
            </Sider>
            <Layout>
                {/*<Tabs*/}
                {/*    id="layout-note" type="editable-card"*/}
                {/*    onChange={onChange} activeKey={activeKey}*/}
                {/*    onEdit={onEdit}*/}
                {/*    items={itemList.map(item => {*/}
                {/*        return {*/}
                {/*            label: item.label,*/}
                {/*            children: <div className="HlexicalName"><Hlexical filePath={item.children}/></div>,*/}
                {/*            key: item.key*/}
                {/*        }*/}
                {/*    })}*/}
                {/*/>*/}
                <Tabs
                    id="layout-note" type="editable-card"
                    onChange={onChange} activeKey={activeKey}
                    onEdit={onEdit}
                >{
                        itemList.map(item => (
                            <TabPane tab={item.label} key={item.key} children={<div className="HlexicalName"><Hlexical
                                filePath={item.children}/></div>}/>
                        ))
                    }
                </Tabs>
            </Layout>
        </Layout>
    );
};
export default Note;
